# Changelog
All notable changes to this project will be documented in this file.

The format is based on [Keep a Changelog](https://keepachangelog.com/en/1.0.0/),
and this project adheres to [Semantic Versioning](https://semver.org/spec/v2.0.0.html).

## [0.5.1] - 2020-04-30

### Added
- A package comparator implementation that detects deleted files between packages of the same project in different
a version.
- Added new method "::useDateColumns(array $dateColumns)" to Post- and PutTestVerification. The faked test values of
these columns will be represented as datetime string.

### Changed
- AbstractApiTestCase is now expecting the path to a database fixture instead of an object

- All ApiTestCase classes are now based on the doctrine DBAl connection

- Refactored db fixture import mechanisms. There is a new FixtureImporter and FixtureCreator component to either
import or create db fixtures, respectively.

- Moved all other existing classes into src/Tools. The functionality will be moved into a new, dedicated
place. This was done due to project structure refactoring purposes.

### Removed
- a lot of sub-components that were previously used to provide draggers main functionality.
- the whole Gambio\Dragger\Domain\DbFixture namespace files, because the functionality was refactored
- clancats/hydrahon dependency


## [0.5.0] - 2020-04-24

### Added 
 - Doctrine DBAl Dependency
 - FixtureImporter using doctrine connection and providing methods to import fixtures

## [0.4.1] - 2019-12-06

### Fixed 
 - Fixed problem import problem, that won't allow null as valid value in datasets.

## [0.4.0] - 2019-09-06

### Added 
 - New AssertApi methods: assertPutRequest, assertDeleteRequest
 - POST test - A custom request body and/or url placeholder can be provided.
 - Delete/Put testing: Using expectations for verification.
### Changed 
 - RestDocsRepository is private and hidden, Endpoints must be fetched from AbstractTestCase::endpoint method.
 - DeleteTestVerification uses different approach for validation (see added).
 - PutTestVerification uses different approach for validation (see added).
### Removed 
 - Some AssertApi methods: assertDataSetRemoved, assertDataSetChanged. Additionally, the related TestCase method where
 removed too.
### Fixed 
 - Fixed problem that PathValidator didnt accept any floats or numeric integers, if schema path parameter is of type "number".

## [0.3.1] - 2019-08-23
### Added
- Simple event listener implementation.
- Added response schema validation for put testing assertion.
- PutTestCase::assertDataSetChanged additionally verifies status code and response schema
- PostTestCase::assertDataSetAdded additionally verifies status code and response schema

### Changed
- Put test verification has additional url placeholder values.

### Fixed
- Fixed a bug where nullable property mistakenly raised failure in test (but should be allowed).
- Fixed a bug where object list properties validation succeeds on error.
- Fixed a bug where empty arrays triggers mistakenly failures.


## [0.3.0] - 2019-08-22
### Added
- New abstract TestCase class post POST-REST endpoints. This class verifies that new data sets where
added after requesting the api.
- New abstract TestCase class post PUT-REST endpoints. This class verifies that existing data sets where
changed after requesting the api.
- New abstract TestCase class for DELETE-REST endpoints. Like the GET test case, the documentation
file will be used to verify the endpoints response. Additionally, removed data sets can be
verified as well.
- A changelog file is now available (this here :P).
- Assertion (including constraint) for status codes.
- Assertion (including constraint) for post request verification.
- Assertion (including constraint) for put request verification.
- Assertion (including constraint) for delete request verification.
- SchemaDataFaker: Component that creates random data sets from schema model (mostly used by post request).
- PutRequestFaker: Like SchemaDataFaker, but dedicated to put request (by adjusting the id).
- IdentifierChanger: Used in conjunction with SchemaDataFaker to create valid PUT request bodies.

### Changed
- The "Conf" objects got renamed to "Configuration" and was moved into a separate directory.
- README updated, so it should be easier to understand and also provide information about
REST-API endpoint testing.
- Changed namespace of abstract api test case classes from "Gambio\Dragger\Domain\Testing\Api" to
"Gambio\Dragger\Domain\Testing\Api\TestCase"

### Fixed
- The creation of request body parameter with list references (schema.type = array|schema.items.$ref = 'path/to/model)
- Sometimes, response schema validation fails due to array values. This was fixed by using phpunit's value exporter.

## [0.2.0] - 2019-07-19
### Added
- New abstract TestCase class for GET-REST endpoints. By providing the path to endpoint documentation
file and some further setup (like data sets to be imported), the test case will parse the
documentation and verify this result again real api responses.
- Command to execute the whole gambio shop installation process.

### Changes
- The whole application core was refactored for a better scaling in future.

### Removed
- The command to create a swagger json file was removed, because it isn't needed anymore
- CLIMate dependency was removed.

## [0.1.0] - 2019-04-18
### Added
- Command to create swagger.json from gambio rest documentation files.
- Command to create tests.config.inc.php for gambio shop development.
- Command to create database fixtures (PHP-Array) from mysql database tables.
- Command to import database fixtures (PHP-Array) in a mysql database.
- Command to execute all sql files in a directory.

[Unreleased]: https://sources.gambio-server.net/gx-testing/dragger/compare/v0.5.0...develop
[0.5.1]: https://sources.gambio-server.net/gx-testing/dragger/compare/v0.5.0...v0.5.1
[0.5.0]: https://sources.gambio-server.net/gx-testing/dragger/compare/v0.4.1...v0.5.0
[0.4.1]: https://sources.gambio-server.net/gx-testing/dragger/compare/v0.4.0...v0.4.1
[0.4.0]: https://sources.gambio-server.net/gx-testing/dragger/compare/v0.3.1...v0.4.0
[0.3.1]: https://sources.gambio-server.net/gx-testing/dragger/compare/v0.3.0...v0.3.1
[0.3.0]: https://sources.gambio-server.net/gx-testing/dragger/compare/v0.2.0...v0.3.0
[0.2.0]: https://sources.gambio-server.net/gx-testing/dragger/compare/v0.1.0...v0.2.0
[0.1.0]: https://sources.gambio-server.net/gx-testing/dragger/commits/v0.1.0
