<?php
/* --------------------------------------------------------------
 Responses.php 2019-07-03
 Gambio GmbH
 http://www.gambio.de
 Copyright (c) 2019 Gambio GmbH
 Released under the GNU General Public License (Version 2)
 [http://www.gnu.org/licenses/gpl-2.0.html]
 --------------------------------------------------------------
 */

declare(strict_types=1);

namespace Gambio\Dragger\ApiTesting\SwaggerLike\Model\Collection;

use Gambio\Dragger\ApiTesting\SwaggerLike\Model\Response;

/**
 * Class Responses
 *
 * @package Gambio\Dragger\ApiTesting\SwaggerLike\Model\Collection
 */
class Responses
{
    /**
     * @var Response[]
     */
    private $items = [];
    
    
    /**
     * @return Responses
     */
    public static function create() : self
    {
        return new static();
    }
    
    
    /**
     * Adds new collection item.
     *
     * @param Response $parameter
     */
    public function add(Response $parameter) : void
    {
        $this->items[] = $parameter;
    }
    
    
    /**
     * @return Response[]
     */
    public function items() : array
    {
        return $this->items;
    }
}