<?php
/* --------------------------------------------------------------
 PropertyReference.php 2019-07-04
 Gambio GmbH
 http://www.gambio.de
 Copyright (c) 2019 Gambio GmbH
 Released under the GNU General Public License (Version 2)
 [http://www.gnu.org/licenses/gpl-2.0.html]
 --------------------------------------------------------------
 */

declare(strict_types=1);

namespace Gambio\Dragger\ApiTesting\SwaggerLike\Model\Reference;

use Webmozart\Assert\Assert;

/**
 * Class PropertyReference
 *
 * @package Gambio\Dragger\ApiTesting\SwaggerLike\Model\Reference
 */
class PropertyReference extends AbstractReference
    implements \Gambio\Dragger\ApiTesting\SwaggerLike\Model\Contracts\PropertyReference
{
    /**
     * Factory method for PropertyReference.
     *
     * @param array $data
     *
     * @return PropertyReference
     */
    public static function fromArray(array $data) : self
    {
        Assert::keyExists($data, '$ref');
        $value = $data['$ref'];
        Assert::string($value);
        
        return new static($value);
    }
}