<?php
/* --------------------------------------------------------------
 RestDocRepository.php 2019-07-03
 Gambio GmbH
 http://www.gambio.de
 Copyright (c) 2019 Gambio GmbH
 Released under the GNU General Public License (Version 2)
 [http://www.gnu.org/licenses/gpl-2.0.html]
 --------------------------------------------------------------
 */

declare(strict_types=1);

namespace Gambio\Dragger\ApiTesting\SwaggerLike\Model;

use Gambio\Dragger\ApiTesting\SwaggerLike\Model\Contracts\Schema;

/**
 * Interface RestDocRepository
 *
 * @package Gambio\Dragger\ApiTesting\SwaggerLike\Model
 */
interface RestDocRepository
{
    /**
     * Returns the endpoint documentation.
     *
     * @param string $filepath
     *
     * @return Endpoint
     */
    public function getEndpointDoc(string $filepath) : Endpoint;
    
    
    /**
     * Resolves the schema of the response.
     *
     * @param Response $response
     *
     * @return Schema
     */
    public function resolveResponseSchema(Response $response) : Schema;
}