<?php
/* --------------------------------------------------------------
 SchemaListScalar.php 2019-07-18
 Gambio GmbH
 http://www.gambio.de
 Copyright (c) 2019 Gambio GmbH
 Released under the GNU General Public License (Version 2)
 [http://www.gnu.org/licenses/gpl-2.0.html]
 --------------------------------------------------------------
 */

declare(strict_types=1);

namespace Gambio\Dragger\ApiTesting\SwaggerLike\Model\Schema;

use Gambio\Dragger\ApiTesting\SwaggerLike\Model\Contracts\TypedAndNamed;

/**
 * Class SchemaListScalar
 * @package Gambio\Dragger\ApiTesting\SwaggerLike\Model\Schema
 */
class SchemaListScalar implements \Gambio\Dragger\ApiTesting\SwaggerLike\Model\Contracts\SchemaList, TypedAndNamed
{
    /**
     * @var string
     */
    private $name;
    
    /**
     * @var string
     */
    private $type;
    
    
    /**
     * SchemaListScalar constructor.
     *
     * @param string $name
     * @param string $type
     */
    private function __construct(string $name, string $type)
    {
        $this->name = $name;
        $this->type = $type;
    }
    
    
    /**
     * Factory method for SchemaListScalar.
     *
     * @param string $name
     * @param string $type
     *
     * @return SchemaListScalar
     */
    public static function create(string $name, string $type) : self
    {
        return new static($name, $type);
    }
    
    
    /**
     * @return string
     */
    public function name() : string
    {
        return $this->name;
    }
    
    
    /**
     * @return string
     */
    public function type() : string
    {
        return $this->type;
    }
}