<?php
/* --------------------------------------------------------------
 Directories.php 2020-04-24
 Gambio GmbH
 http://www.gambio.de
 Copyright (c) 2020 Gambio GmbH
 Released under the GNU General Public License (Version 2)
 [http://www.gnu.org/licenses/gpl-2.0.html]
 --------------------------------------------------------------
 */

namespace Gambio\Dragger\PackageComparator\Model\Collections;

use ArrayIterator;
use Gambio\Dragger\PackageComparator\Model\Directory;
use IteratorAggregate;

/**
 * Class Directories
 * @package Gambio\Dragger\PackageComparator\Model\Collections
 */
class Directories implements IteratorAggregate
{
    /**
     * @var Directory[]
     */
    private $directories = [];
    
    
    /**
     * Directories constructor.
     */
    private function __construct()
    {
    }
    
    
    /**
     * Factory method for directories.
     *
     * @return static
     */
    public static function create(): self
    {
        return new static();
    }
    
    
    /**
     * @param Directory $directory
     */
    public function add(Directory $directory): void
    {
        $this->directories[] = $directory;
    }
    
    
    /**
     * @return Directory[]
     */
    public function getIterator(): iterable
    {
        return new ArrayIterator($this->directories);
    }
}