<?php
/* --------------------------------------------------------------
 Files.php 2020-04-24
 Gambio GmbH
 http://www.gambio.de
 Copyright (c) 2020 Gambio GmbH
 Released under the GNU General Public License (Version 2)
 [http://www.gnu.org/licenses/gpl-2.0.html]
 --------------------------------------------------------------
 */

namespace Gambio\Dragger\PackageComparator\Model\Collections;

use ArrayIterator;
use Gambio\Dragger\PackageComparator\Model\File;
use IteratorAggregate;

/**
 * Class Files
 * @package Gambio\Dragger\PackageComparator\Model\Collections
 */
class Files implements IteratorAggregate
{
    /**
     * @var Files[]
     */
    private $files = [];
    
    
    /**
     * Files constructor.
     */
    private function __construct()
    {
    }
    
    
    /**
     * Factory method for files.
     *
     * @return static
     */
    public static function create(): self
    {
        return new static();
    }
    
    
    /**
     * @param File $file
     */
    public function add(File $file): void
    {
        $this->files[] = $file;
    }
    
    
    /**
     * @return File[]
     */
    public function getIterator(): iterable
    {
        return new ArrayIterator($this->files);
    }
}