<?php
/* --------------------------------------------------------------
 ComparePackage.php 2020-04-21
 Gambio GmbH
 http://www.gambio.de
 Copyright (c) 2020 Gambio GmbH
 Released under the GNU General Public License (Version 2)
 [http://www.gnu.org/licenses/gpl-2.0.html]
 --------------------------------------------------------------
 */

namespace Gambio\Dragger\PackageComparator\Model;

/**
 * Class ComparePackage
 * @package Gambio\Dragger\PackageComparator\Model
 */
class ComparePackage
{
    /**
     * @var string
     */
    private $name;
    
    /**
     * @var Directory
     */
    private $root;
    
    
    /**
     * ComparePackage constructor.
     *
     * @param string    $name
     * @param Directory $root
     */
    private function __construct(string $name, Directory $root)
    {
        $this->name = $name;
        $this->root = $root;
    }
    
    
    /**
     * Factory method for ComparePackage.
     *
     * @param string    $name
     * @param Directory $root
     *
     * @return static
     */
    public static function create(string $name, Directory $root): self
    {
        return new static($name, $root);
    }
    
    
    /**
     * @return string
     */
    public function name(): string
    {
        return $this->name;
    }
    
    
    /**
     * @return Directory
     */
    public function root(): Directory
    {
        return $this->root;
    }
}