<?php
/* --------------------------------------------------------------
 File.php 2020-04-24
 Gambio GmbH
 http://www.gambio.de
 Copyright (c) 2020 Gambio GmbH
 Released under the GNU General Public License (Version 2)
 [http://www.gnu.org/licenses/gpl-2.0.html]
 --------------------------------------------------------------
 */

namespace Gambio\Dragger\PackageComparator\Model;

/**
 * Class File
 * @package Gambio\Dragger\PackageComparator\Model
 */
class File
{
    /**
     * @var string
     */
    private $name;
    
    /**
     * @var string
     */
    private $absolutePath;
    
    /**
     * @var string
     */
    private $relativePath;
    
    
    /**
     * File constructor.
     *
     * @param string $name
     * @param string $absolutePath
     * @param string $relativePath
     */
    public function __construct(string $name, string $absolutePath, string $relativePath)
    {
        $this->name         = $name;
        $this->absolutePath = $absolutePath;
        $this->relativePath = $relativePath;
    }
    
    
    /**
     * Factory method for File.
     *
     * @param string $name
     * @param string $absolutePath
     * @param string $relativePath
     *
     * @return static
     */
    public static function create(string $name, string $absolutePath, string $relativePath): self
    {
        return new static($name, $absolutePath, $relativePath);
    }
    
    
    /**
     * @return string
     */
    public function name(): string
    {
        return $this->name;
    }
    
    
    /**
     * @return string
     */
    public function absolutePath(): string
    {
        return $this->absolutePath;
    }
    
    
    /**
     * @return string
     */
    public function relativePath(): string
    {
        return $this->relativePath;
    }
}