<?php
/* --------------------------------------------------------------
 DbCredentials.php 2019-06-07
 Gambio GmbH
 http://www.gambio.de
 Copyright (c) 2019 Gambio GmbH
 Released under the GNU General Public License (Version 2)
 [http://www.gnu.org/licenses/gpl-2.0.html]
 --------------------------------------------------------------
 */

declare(strict_types=1);

namespace Gambio\Dragger\Tools\Contracts\Configuration;

/**
 * Interface DbCredentials
 * @package Gambio\Dragger\Tools\Contracts\Configuration
 */
interface DbCredentials
{
    /**
     * Database host.
     *
     * @return string
     */
    public function dbHost() : string;
    
    
    /**
     * Database user.
     *
     * @return string
     */
    public function dbUser() : string;
    
    
    /**
     * Database password.
     *
     * @return string
     */
    public function dbPassword() : string;
    
    
    /**
     * Database name.
     *
     * @return string
     */
    public function dbName() : string;
}