<?php
/* --------------------------------------------------------------
 SqlFileCollection.php 2019-06-13
 Gambio GmbH
 http://www.gambio.de
 Copyright (c) 2019 Gambio GmbH
 Released under the GNU General Public License (Version 2)
 [http://www.gnu.org/licenses/gpl-2.0.html]
 --------------------------------------------------------------
 */

declare(strict_types=1);

namespace Gambio\Dragger\Tools\Domain\Commands\Sql;

use ArrayIterator;
use IteratorAggregate;

/**
 * Class SqlFileCollection
 * @package Gambio\Dragger\Tools\Domain\Commands\Sql
 */
class SqlFileCollection implements IteratorAggregate
{
    /**
     * @var array
     */
    private $items = [];
    
    
    /**
     * SqlFileCollection constructor.
     */
    private function __construct()
    {
    }
    
    
    /**
     * Factory method for sql file collection.
     *
     * @return SqlFileCollection
     */
    public static function create() : self
    {
        return new static();
    }
    
    
    /**
     * @param SqlFile $sqlFile
     */
    public function add(SqlFile $sqlFile) : void
    {
        $this->items[] = $sqlFile;
    }
    
    
    /**
     * @codeCoverageIgnore
     */
    public function getIterator()
    {
        return new ArrayIterator($this->items);
    }
}