<?php
/* --------------------------------------------------------------
 SqlRepository.php 2019-06-13
 Gambio GmbH
 http://www.gambio.de
 Copyright (c) 2019 Gambio GmbH
 Released under the GNU General Public License (Version 2)
 [http://www.gnu.org/licenses/gpl-2.0.html]
 --------------------------------------------------------------
 */

declare(strict_types=1);

namespace Gambio\Dragger\Tools\Domain\Commands\Sql;

/**
 * Interface SqlRepository
 * @package Gambio\Dragger\Tools\Domain\Commands\Sql
 */
interface SqlRepository
{
    /**
     * Scans the given path for sql files and returns a collection of them.
     *
     * @param Path $path
     *
     * @return SqlFileCollection
     */
    public function scan(Path $path) : SqlFileCollection;
    
    
    /**
     * Imports an sql file.
     *
     * @param SqlFile $sqlFile
     */
    public function import(SqlFile $sqlFile) : void;
}
