<?php
/* --------------------------------------------------------------
 Fixture.php 2019-06-07
 Gambio GmbH
 http://www.gambio.de
 Copyright (c) 2019 Gambio GmbH
 Released under the GNU General Public License (Version 2)
 [http://www.gnu.org/licenses/gpl-2.0.html]
 --------------------------------------------------------------
 */

declare(strict_types=1);

namespace Gambio\Dragger\Tools\Domain\DbFixture;

use Webmozart\Assert\Assert;

/**
 * Class Fixture
 * @package Gambio\Dragger\Tools\Domain\DbFixture
 */
class Fixture
{
    /**
     * @var array
     */
    private $data;
    
    
    /**
     * Fixture constructor.
     *
     * @param array $data
     */
    private function __construct(array $data)
    {
        $this->data = $data;
    }
    
    
    /**
     * Factory method for database fixture.
     *
     * @param string $filepath
     *
     * @return Fixture
     */
    public static function fromFile(string $filepath) : self
    {
        Assert::fileExists($filepath);
        Assert::file($filepath);
        
        /** @noinspection PhpIncludeInspection */
        $data = include $filepath;
        
        Assert::isArray($data);
        
        return new static($data);
    }
    
    
    /**
     * Fixture data.
     *
     * @return array
     */
    public function data() : array
    {
        return $this->data;
    }
}