<?php
/* --------------------------------------------------------------
 NewFixture.php 2019-06-07
 Gambio GmbH
 http://www.gambio.de
 Copyright (c) 2019 Gambio GmbH
 Released under the GNU General Public License (Version 2)
 [http://www.gnu.org/licenses/gpl-2.0.html]
 --------------------------------------------------------------
 */

declare(strict_types=1);

namespace Gambio\Dragger\Tools\Domain\DbFixture;

/**
 * Class NewFixture
 * @package Gambio\Dragger\Tools\Domain\DbFixture
 */
class NewFixture
{
    /**
     * @var string
     */
    private $content;
    
    
    /**
     * Fixture constructor.
     *
     * @param string $content
     */
    private function __construct(string $content)
    {
        $this->content = $content;
    }
    
    
    /**
     * Factory method of fixture.
     *
     * @param string $content
     *
     * @return NewFixture
     */
    public static function fromString(string $content) : self
    {
        return new static($content);
    }
    
    
    /**
     * Database fixture content.
     *
     * @return string
     */
    public function content() : string
    {
        return <<<CONTENT
<?php

{$this->content}
CONTENT;
    }
}