<?php
/* --------------------------------------------------------------
 Service.php 2019-06-07
 Gambio GmbH
 http://www.gambio.de
 Copyright (c) 2019 Gambio GmbH
 Released under the GNU General Public License (Version 2)
 [http://www.gnu.org/licenses/gpl-2.0.html]
 --------------------------------------------------------------
 */

declare(strict_types=1);

namespace Gambio\Dragger\Tools\Domain\DbFixture;

/**
 * Class Service
 * @package Gambio\Dragger\Tools\Domain\DbFixture
 */
class Service
{
    /**
     * @var DbFixtureRepository
     */
    private $repository;
    
    
    /**
     * Service constructor.
     *
     * @param DbFixtureRepository $repository
     */
    public function __construct(DbFixtureRepository $repository)
    {
        $this->repository = $repository;
    }
    
    
    /**
     * Creates a database fixture and saves the content to destination.
     *
     * @param Tables      $tables
     * @param Destination $destination
     */
    public function createFixture(Tables $tables, Destination $destination): void
    {
        $fixture = $this->repository->create($tables);
        $this->repository->save($fixture, $destination);
    }
    
    
    /**
     * Imports the database fixture.
     *
     * @param Fixture $fixture
     */
    public function importFixture(Fixture $fixture): void
    {
        $this->repository->import($fixture);
    }
}