<?php
/* --------------------------------------------------------------
 Tables.php 2019-06-07
 Gambio GmbH
 http://www.gambio.de
 Copyright (c) 2019 Gambio GmbH
 Released under the GNU General Public License (Version 2)
 [http://www.gnu.org/licenses/gpl-2.0.html]
 --------------------------------------------------------------
 */

declare(strict_types=1);

namespace Gambio\Dragger\Tools\Domain\DbFixture;

use Webmozart\Assert\Assert;

/**
 * Class Tables
 * @package Gambio\Dragger\Tools\Domain\DbFixture
 */
class Tables
{
    /**
     * @var string[]
     */
    private $tables;
    
    
    /**
     * Tables constructor.
     *
     * @param string ...$tables
     */
    private function __construct(string ...$tables)
    {
        Assert::notEmpty($tables, '$tables must not be empty!');
        $this->tables = $tables;
    }
    
    
    /**
     * Factory method of tables.
     *
     * @param string ...$tables
     *
     * @return Tables
     */
    public static function fromList(string ...$tables) : self
    {
        return new static(...$tables);
    }
    
    
    /**
     * List of tables.
     *
     * @return array
     */
    public function list() : array
    {
        return $this->tables;
    }
}