<?php /** @noinspection SqlResolve */
/* --------------------------------------------------------------
 PdoMySqlReader.php 2019-06-07
 Gambio GmbH
 http://www.gambio.de
 Copyright (c) 2019 Gambio GmbH
 Released under the GNU General Public License (Version 2)
 [http://www.gnu.org/licenses/gpl-2.0.html]
 --------------------------------------------------------------
 */

declare(strict_types=1);

namespace Gambio\Dragger\Tools\Infrastructure\Persistence\DbFixture;

use PDO;

/**
 * Class PdoMySqlReader
 * @package Gambio\Dragger\Tools\Infrastructure\Persistence\DbFixture
 */
class PdoMySqlReader
{
    /**
     * @var PDO
     */
    private $pdo;
    
    
    /**
     * PdoMySqlReader constructor.
     *
     * @param PDO $pdo
     */
    public function __construct(PDO $pdo)
    {
        $this->pdo = $pdo;
    }
    
    
    /**
     * Fetches all data from the given table.
     *
     * @param array $tables
     *
     * @return array
     */
    public function fetchData(array $tables) : array
    {
        $data = [];
        
        foreach ($tables as $table) {
            $query        = "SELECT * FROM `{$table}`;";
            $data[$table] = $this->pdo->query($query)->fetchAll();
        }
        
        return $data;
    }
}