<?php
/* --------------------------------------------------------------
 PathTest.php 2019-06-13
 Gambio GmbH
 http://www.gambio.de
 Copyright (c) 2019 Gambio GmbH
 Released under the GNU General Public License (Version 2)
 [http://www.gnu.org/licenses/gpl-2.0.html]
 --------------------------------------------------------------
 */

declare(strict_types=1);

namespace Gambio\Dragger\Tools\Domain\Commands\Sql;

use InvalidArgumentException;
use PHPUnit\Framework\TestCase;

class PathTest extends TestCase
{
    public function testExposesPath() : void
    {
        $path = __DIR__;
        $this->assertEquals($path, Path::fromString($path)->toString());
    }
    
    
    public function testRejectsFilePath() : void
    {
        $this->expectException(InvalidArgumentException::class);
        Path::fromString(__FILE__);
    }
    
    
    public function testRejectsNonExistingPaths() : void
    {
        $this->expectException(InvalidArgumentException::class);
        Path::fromString(__DIR__ . '/invalid');
    }
}