<?php
/* --------------------------------------------------------------
 RequestConfigurationTest.php 2019-08-15
 Gambio GmbH
 http://www.gambio.de
 Copyright (c) 2019 Gambio GmbH
 Released under the GNU General Public License (Version 2)
 [http://www.gnu.org/licenses/gpl-2.0.html]
 --------------------------------------------------------------
 */

declare(strict_types=1);

namespace Gambio\Dragger\ApiTesting\SwaggerLike\Configuration;

use PHPUnit\Framework\TestCase;

class RequestConfigurationTest extends TestCase
{
    /**
     * @var RequestConfiguration
     */
    private $config;
    
    /**
     * @var string
     */
    private $baseUrl;
    
    /**
     * @var string
     */
    private $user;
    
    /**
     * @var string
     */
    private $password;
    
    
    protected function setUp()
    {
        $this->baseUrl  = 'https://foo';
        $this->user     = 'bar';
        $this->password = 'baz';
        
        $this->config = RequestConfiguration::create($this->baseUrl, $this->user, $this->password);
    }
    
    
    public function testHasBaseUrl() : void
    {
        $this->assertEquals($this->baseUrl . '/', $this->config->baseUrl());
    }
    
    
    public function testHasUser() : void
    {
        $this->assertEquals($this->user, $this->config->user());
    }
    
    
    public function testHasPassword() : void
    {
        $this->assertEquals($this->password, $this->config->password());
    }
}
