<?php
/* --------------------------------------------------------------
 ParameterCommonTest.php 2019-08-05
 Gambio GmbH
 http://www.gambio.de
 Copyright (c) 2019 Gambio GmbH
 Released under the GNU General Public License (Version 2)
 [http://www.gnu.org/licenses/gpl-2.0.html]
 --------------------------------------------------------------
 */

declare(strict_types=1);

namespace Gambio\Dragger\ApiTesting\SwaggerLike\Model\Parameter;

use Faker\Factory;
use PHPUnit\Framework\TestCase;

class ParameterCommonTest extends TestCase
{
    /**
     * @var ParameterCommon
     */
    private $parameter;
    
    /**
     * @var string
     */
    private $paramName;
    
    /**
     * @var string
     */
    private $in;
    
    /**
     * @var bool
     */
    private $required;
    
    /**
     * @var bool
     */
    private $isList;
    
    
    protected function setUp()
    {
        $faker = Factory::create('de_DE');
        
        $this->paramName = $faker->word;
        $this->in        = $faker->boolean ? 'path' : 'body';
        $this->required  = $faker->boolean;
        $this->isList    = $faker->boolean;
        
        $this->parameter = ParameterCommon::create(
            $this->paramName, $this->in, $this->required, $this->isList
        );
    }
    
    
    public function testHasName() : void
    {
        $this->assertEquals($this->paramName, $this->parameter->name());
    }
    
    
    public function testHasIn() : void
    {
        $this->assertEquals($this->in, $this->parameter->in());
    }
    
    
    public function testCanBeRequired() : void
    {
        $this->assertEquals($this->required, $this->parameter->required());
    }
    
    
    public function testCanBeList() : void
    {
        $this->assertEquals($this->isList, $this->parameter->isList());
    }
}
