<?php
/* --------------------------------------------------------------
 ParameterInTest.php 2019-08-05
 Gambio GmbH
 http://www.gambio.de
 Copyright (c) 2019 Gambio GmbH
 Released under the GNU General Public License (Version 2)
 [http://www.gnu.org/licenses/gpl-2.0.html]
 --------------------------------------------------------------
 */

namespace Gambio\Dragger\ApiTesting\SwaggerLike\Model\Parameter;

use PHPUnit\Framework\TestCase;

class ParameterInTest extends TestCase
{
    public function testIsSimpleEnum() : void
    {
        $inBody = ParameterIn::body();
        $inPath = ParameterIn::path();
        
        $errors = [];
        
        switch ((string)$inBody) {
            case ParameterIn::IN_PATH:
                $errors[] = 'Failed asserting that $inBody not matching ParameterIn::IN_PATH.';
                break;
            case ParameterIn::IN_BODY:
                // all ok
                break;
            default:
                $errors[] = 'Failed asserting that $inBody matches ParameterIn::IN_BODY.';
                break;
        }
        
        switch ((string)$inPath) {
            case ParameterIn::IN_BODY:
                $errors[] = 'Failed asserting that $inPath not matching ParameterIn::IN_BODY.';
                break;
            case ParameterIn::IN_PATH:
                // all ok
                break;
            default:
                $errors[] = 'Failed asserting that $inBody matches ParameterIn::IN_BODY.';
                break;
        }
        
        $this->assertCount(0, $errors, implode(PHP_EOL, $errors));
    }
}
