<?php
/* --------------------------------------------------------------
 ReferencedPropertyTest.php 2019-07-04
 Gambio GmbH
 http://www.gambio.de
 Copyright (c) 2019 Gambio GmbH
 Released under the GNU General Public License (Version 2)
 [http://www.gnu.org/licenses/gpl-2.0.html]
 --------------------------------------------------------------
 */

declare(strict_types=1);

namespace Gambio\Dragger\ApiTesting\SwaggerLike\Model\Property;

use Faker\Factory;
use Faker\Generator;
use Gambio\Dragger\ApiTesting\SwaggerLike\Model\Contracts\PropertyReference;
use PHPUnit\Framework\TestCase;

class ReferencedPropertyTest extends TestCase
{
    /**
     * @var ReferencedProperty
     */
    private $property;
    
    /**
     * @var Generator
     */
    private $faker;
    
    /**
     * @var string
     */
    private $propName;
    
    /**
     * @var string
     */
    private $reference;
    
    
    protected function setUp()
    {
        $this->faker = Factory::create('de_DE');
        
        $this->propName  = $this->faker->word;
        $this->reference = $this->createMock(PropertyReference::class);
        
        $this->property = ReferencedProperty::create($this->propName, $this->reference);
    }
    
    
    public function testHasName() : void
    {
        $this->assertEquals($this->propName, $this->property->name());
    }
    
    
    public function testHasReference() : void
    {
        $this->assertEquals($this->reference, $this->property->reference());
    }
}