<?php
/* --------------------------------------------------------------
 SchemaListScalarTest.php 2019-07-18
 Gambio GmbH
 http://www.gambio.de
 Copyright (c) 2019 Gambio GmbH
 Released under the GNU General Public License (Version 2)
 [http://www.gnu.org/licenses/gpl-2.0.html]
 --------------------------------------------------------------
 */

declare(strict_types=1);

namespace Gambio\Dragger\ApiTesting\SwaggerLike\Model\Schema;

use Faker\Factory;
use PHPUnit\Framework\TestCase;

class SchemaListScalarTest extends TestCase
{
    private $schema;
    
    private $title;
    
    private $type;
    
    
    protected function setUp()
    {
        $faker = Factory::create('de_DE');
        
        $this->title = $faker->word;
        $value       = $faker->randomElement([1, 'string']);
        $this->type  = gettype($value);
        
        $this->schema = SchemaListScalar::create($this->title, $this->type);
    }
    
    
    public function testHasTitle() : void
    {
        $this->assertEquals($this->title, $this->schema->name());
    }
    
    
    public function testHasType() : void
    {
        $this->assertEquals($this->type, $this->schema->type());
    }
}
