<?php
/* --------------------------------------------------------------
 SchemaTest.php 2019-07-04
 Gambio GmbH
 http://www.gambio.de
 Copyright (c) 2019 Gambio GmbH
 Released under the GNU General Public License (Version 2)
 [http://www.gnu.org/licenses/gpl-2.0.html]
 --------------------------------------------------------------
 */

declare(strict_types=1);

namespace Gambio\Dragger\ApiTesting\SwaggerLike\Model\Schema;

use Faker\Factory;
use Gambio\Dragger\ApiTesting\SwaggerLike\Model\Collection\Properties;
use PHPUnit\Framework\TestCase;

class SchemaTest extends TestCase
{
    /**
     * @var Schema
     */
    private $schema;
    
    /**
     * @var string
     */
    private $title;
    
    /**
     * @var string
     */
    private $properties;
    
    /**
     * @var string
     */
    private $required;
    
    
    protected function setUp() : void
    {
        $faker = Factory::create('de_DE');
        
        $this->title      = $faker->word;
        $this->properties = $this->createMock(Properties::class);
        $this->required   = $faker->randomElements(['foo', 'bar', 'baz']);
        
        $this->schema = Schema::create($this->title, $this->properties, $this->required);
    }
    
    
    public function testHasTitle() : void
    {
        $this->assertEquals($this->title, $this->schema->name());
    }
    
    
    public function testHasProperties() : void
    {
        $this->assertSame($this->properties, $this->schema->properties());
    }
    
    
    public function testHasRequiredInfo() : void
    {
        $this->assertEquals($this->required, $this->schema->required());
    }
}