<?php
/* --------------------------------------------------------------
 ComparePackageTest.php 2020-04-22
 Gambio GmbH
 http://www.gambio.de
 Copyright (c) 2020 Gambio GmbH
 Released under the GNU General Public License (Version 2)
 [http://www.gnu.org/licenses/gpl-2.0.html]
 --------------------------------------------------------------
 */

namespace Gambio\Dragger\PackageComparator\Model;

use PHPUnit\Framework\MockObject\MockObject;
use PHPUnit\Framework\TestCase;

class ComparePackageTest extends TestCase
{
    /**
     * @var ComparePackage
     */
    private $package;
    
    /**
     * @var string
     */
    private $packageName;
    
    /**
     * @var Directory|MockObject
     */
    private $root;
    
    
    protected function setUp(): void
    {
        $this->package = ComparePackage::create(
            $this->packageName = 'name',
            $this->root = $this->createMock(Directory::class)
        );
    }
    
    
    public function testHasAccessorForName(): void
    {
        $this->assertSame($this->packageName, $this->package->name());
    }
    
    
    public function testHasAccessorForRootDirectory(): void
    {
        $this->assertSame($this->root, $this->package->root());
    }
}