<?php
/* --------------------------------------------------------------
 FileTest.php 2020-04-24
 Gambio GmbH
 http://www.gambio.de
 Copyright (c) 2020 Gambio GmbH
 Released under the GNU General Public License (Version 2)
 [http://www.gnu.org/licenses/gpl-2.0.html]
 --------------------------------------------------------------
 */

namespace Gambio\Dragger\PackageComparator\Model;

use PHPUnit\Framework\TestCase;

class FileTest extends TestCase
{
    private $file;
    
    private $name;
    
    private $absolute;
    
    private $relative;
    
    
    protected function setUp(): void
    {
        $this->file = File::create($this->name = 'name', $this->absolute = 'absolute', $this->relative = 'relative');
    }
    
    
    public function testHasAccessorForName(): void
    {
        $this->assertEquals($this->name, $this->file->name());
    }
    
    
    public function testHasAccessorForAbsolutePath(): void
    {
        $this->assertEquals($this->absolute, $this->file->absolutePath());
    }
    
    
    public function testHasAccessorForRelativePath(): void
    {
        $this->assertEquals($this->relative, $this->file->relativePath());
    }
}